package urfavecli

import (
	"fmt"
	"strings"

	"github.com/urfave/cli/v2"
	"go-micro.dev/v4/broker"
	"jochum.dev/jo-micro/jo/generic"
)

type BrokerFlags []cli.Flag

func ProvideBrokerFlags(prefix Prefix) BrokerFlags {
	return BrokerFlags{
		&cli.StringFlag{
			Name:    fmt.Sprintf("%s_broker", strings.ToLower(string(prefix))),
			Usage:   "Broker for pub/sub. http, nats, rabbitmq",
			Value:   "http",
			EnvVars: []string{fmt.Sprintf("%s_BROKER", strings.ToUpper(string(prefix)))},
		},
	}
}

func ProvideBroker(prefix Prefix, c *cli.Context, _ BrokerFlags) (broker.Broker, error) {
	return generic.Brokers.Get(c.String(fmt.Sprintf("%s_broker", strings.ToLower(string(prefix)))))
}
