package urfavecli

import "github.com/urfave/cli/v2"

type Options struct {
	Prefix  string
	Name    string
	Version string
	Usage   string
	Flags   []cli.Flag
}

type Option func(*Options)

func WithPrefix(n string) Option {
	return func(o *Options) {
		o.Prefix = n
	}
}

func WithName(n string) Option {
	return func(o *Options) {
		o.Name = n
	}
}

func WithVersion(n string) Option {
	return func(o *Options) {
		o.Version = n
	}
}

func WithUsage(n string) Option {
	return func(o *Options) {
		o.Usage = n
	}
}

func WithFlags(n []cli.Flag) Option {
	return func(o *Options) {
		o.Flags = n
	}
}

func ProvideOptions(opts []Option) *Options {
	options := &Options{
		Prefix:  "micro",
		Name:    "",
		Version: "",
		Usage:   "",
		Flags:   []cli.Flag{},
	}

	for _, o := range opts {
		o(options)
	}

	return options
}
