package urfavecli

import (
	"github.com/urfave/cli/v2"
)

type Flags []cli.Flag
type Prefix string

func ProvidePrefix(opts *Options) Prefix {
	return Prefix(opts.Prefix)
}

func NewApp(opts *Options, flags Flags) *cli.App {
	app := cli.NewApp()
	app.Name = opts.Name
	app.Version = opts.Version
	app.Usage = opts.Usage
	app.Flags = []cli.Flag(flags)

	app.Before = func(c *cli.Context) error {
		return nil
	}
	app.After = func(c *cli.Context) error {
		return nil
	}
	app.Action = func(c *cli.Context) error {
		return nil
	}

	if len(opts.Name) == 0 {
		app.HideVersion = true
	}

	return app
}

func NewDefaultFlags(opts *Options) Flags {
	result := []cli.Flag{}
	result = append(result, []cli.Flag(ProvideBrokerFlags(Prefix(opts.Prefix)))...)
	result = append(result, opts.Flags...)
	return Flags(result)
}

func NewMinimalFlags(opts *Options) Flags {
	result := []cli.Flag{}
	result = append(result, opts.Flags...)
	return Flags(result)
}

func Init(opts ...Option) (*cli.App, error) {
	return nil, nil
}
